/*

INI file below it calls the POV file

*/


// Just useful.
#declare ReMul = function (Xr, Xi, Yr, Yi) {Xr * Yr - Xi * Yi};
#declare ImMul = function (Xr, Xi, Yr, Yi) {Xr * Yi + Xi * Yr};

#declare Re2 = function (Zr, Zi) {  Zr*Zr - Zi*Zi};
#declare Im2 = function (Zr, Zi) {2*Zr*Zi};

#declare Re3 = function (Zr, Zi) {  Zr*Zr*Zr - 3*Zr*Zi*Zi};
#declare Im3 = function (Zr, Zi) {3*Zr*Zr*Zi -   Zi*Zi*Zi};

// Change if you like...
#declare End = function (Zr, Zi) {Zr*Zr + Zi*Zi};

// Build recursive definition...
#declare Fn = array[21];

#declare Fn[0] = function (Zr, Zi, Tr, Ti, Br, Bi) {End(Zr, Zi)};

#declare lp=1;
#while (lp<21)
   #declare Fn[lp] = function (Zr, Zi, Tr, Ti, Br, Bi)
   {
     Fn[lp-1]
     (
       Re3(Zr, Zi) - ReMul(Zr, Zi, Tr, Ti) + Br,
       Im3(Zr, Zi) - ImMul(Zr, Zi, Tr, Ti) + Bi,
       Tr, Ti, Br, Bi
     )
   };

   #declare lp = lp + 1;
#end
#undef lp

// Change this at will... (Must be < 20 tho.)
#declare Iterations = 12;

// Don't touch...
#declare InitP = function (Ar, Ai, Br, Bi) {Fn[Iterations](+Ar, +Ai,3*Re2(Ar, Ai), 3*Im2(Ar, Ai), Br, Bi)};
#declare InitM = function (Ar, Ai, Br, Bi) {Fn[Iterations](-Ar, -Ai,3*Re2(Ar, Ai), 3*Im2(Ar, Ai), Br, Bi)};

// Now draw something!!
camera
{ spherical //cylinder  1//orthographic  
angle      180 
   location <0, 0, -4.5>
   look_at <0, 0, 0>
}  


//#declare Klock =0;                               // Use this for none animations


#declare KlockStart = 1.9	;//1.3	;
#declare Klock = (clock * KlockStart *2) -KlockStart	;
#debug concat("clock is:",str(Klock,5,4),"\n")


plane {z,0
  pigment {

	function {min(InitP(z, Klock, x, y) - 4, 10)}    
	colour_map { 
	
/*
Yellow colour map comment out when using the other colours. I used three different files to get three differently named sets of files.

*/


      [0    rgb <0,0,0>]
      [0.33 rgb <0,0,0>]
      [0.33 rgb <1,1,0>] 
      [0.67 rgb <1,1,0>]
      [0.67 rgb <0,0,0>]
      [1.0  rgb <0,0,0>]   
      


//    Red colour map comment out when using the other colours.

/*    
      [0    rgb <0,0,0>]
      [0.33 rgb <0,0,0>]
      [0.67 rgb <1,0,0>] 
      [0.99 rgb <1,0,0>] 
      [1.0  rgb <0,0,0>]
*/



//    Blue colour map comment out when using the other colours.


/*
      [0    rgb <0,0,0>]
      [0.0001 rgb <0,0,1>]   
      [0.33 rgb <0,0,1>]
      [0.33 rgb <0,0,0>]
      [0.67 rgb <0,0,0>]
      [0.85 rgb <0,0,0>]
      [1.0  rgb <0,0,1>]

*/

      
    }
  }  
  hollow
  finish {ambient 1}
  rotate z*90
  scale 2
}


/////////////////////////////////////////////////////// INI file /////////////////////////////////////////////////////////

/*



Antialias=on

Antialias_Threshold=0.1
Antialias_Depth=2
Input_File_Name=Mikes02a.pov

Initial_Frame=1
Final_Frame=360
Initial_Clock=0
Final_Clock=1

Output_File_Name= C:\Data\Images\     

///////////////////////////////////////////// This saves the images in the folder I use.

Output_File_Type=T

Cyclic_Animation=oFF
Pause_when_Done=off

*/

